import * as E from "fp-ts/lib/Either";
import * as t from "io-ts";
export declare const EncryptedPayload: t.TypeC<{
    cypherText: t.StringC;
    iv: t.StringC;
    encryptedKey: t.StringC;
}>;
export type EncryptedPayload = t.TypeOf<typeof EncryptedPayload>;
export declare function toEncryptedPayload(rsaPubKey: string, plainText: string): E.Either<Error, EncryptedPayload>;
export declare function toPlainText(rsaPrivateKey: string, encryptedPayload: EncryptedPayload): E.Either<Error, string>;
