"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toExpressHandler = void 0;
const responses_1 = require("./responses");
/**
 * Convenience method that transforms a function (handler),
 * which takes an express.Request as input and returns an IResponse,
 * into an express controller.
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function toExpressHandler(handler) {
    // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
    return (req, res, object) => __awaiter(this, void 0, void 0, function* () {
        try {
            const response = yield handler.call(object, req);
            response.apply(res);
        }
        catch (e) {
            (0, responses_1.ResponseErrorInternal)(String(e)).apply(res);
        }
    });
}
exports.toExpressHandler = toExpressHandler;
//# sourceMappingURL=express.js.map