import * as t from "io-ts";
export declare const UserAgentSemver: t.TypeC<{
    clientName: import("./types").Tagged<import("./strings").INonEmptyStringTag, string, string, unknown>;
    clientVersion: import("./types").Tagged<import("./strings").IPatternStringTag<"^((0|[1-9]\\d*)\\.){2}(0|[1-9]\\d*)(\\.(0|[1-9]\\d*)){0,1}$">, string, string, unknown>;
}>;
export type UserAgentSemver = t.TypeOf<typeof UserAgentSemver>;
/**
 * this comparator check if the second provided userAgentSemver's version is
 * prior or equal to the first one
 */
export declare const UserAgentSemverValid: {
    equals: (first: UserAgentSemver, second: UserAgentSemver) => boolean;
};
/**
 * This custom decoder validates a string format (i.e AppName/<version>)
 * into a valid UserAgentSemver type object.
 * Encoder turns a UserAgentSemver object into a string representation.
 */
export declare const SemverFromFromUserAgentString: t.Type<{
    clientName: string & import("./strings").INonEmptyStringTag;
    clientVersion: string & import("./strings").IPatternStringTag<"^((0|[1-9]\\d*)\\.){2}(0|[1-9]\\d*)(\\.(0|[1-9]\\d*)){0,1}$">;
}, string, unknown>;
export type SemverFromFromUserAgentString = t.TypeOf<typeof SemverFromFromUserAgentString>;
