import { ValidationError } from "io-ts";
import { Reporter } from "io-ts/lib/Reporter";
/**
 * Translates validation errors to more readable messages.
 */
export declare const errorsToReadableMessages: (es: ReadonlyArray<ValidationError>, isSimplified?: boolean) => ReadonlyArray<string>;
export declare const readableReport: (errors: ReadonlyArray<ValidationError>) => string;
/**
 * A validation error reporter that translates validation errors to more
 * readable messages.
 */
export declare const ReadableReporter: Reporter<ReadonlyArray<string>>;
export declare const readableReportSimplified: (errors: ReadonlyArray<ValidationError>) => string;
/**
 * A validation error reporter that translates validation errors to more
 * readable messages avoiding indexes for types such as t.intersection or t.union.
 */
export declare const ReadableReporterSimplified: Reporter<ReadonlyArray<string>>;
