"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResponseErrorGone = exports.ResponseErrorGatewayTimeout = exports.ResponseErrorServiceTemporarilyUnavailable = exports.ResponseErrorServiceUnavailable = exports.ResponseErrorBadGateway = exports.ResponseErrorInternal = exports.ResponseErrorTooManyRequests = exports.ResponseErrorPreconditionFailed = exports.ResponseErrorConflict = exports.ResponseErrorForbiddenNoAuthorizationGroups = exports.getResponseErrorForbiddenNoAuthorizationGroups = exports.ResponseErrorForbiddenAnonymousUser = exports.ResponseErrorForbiddenNotAuthorizedForDefaultAddresses = exports.ResponseErrorForbiddenNotAuthorizedForRecipient = exports.ResponseErrorForbiddenNotAuthorizedForProduction = exports.ResponseErrorForbiddenNotAuthorized = exports.getResponseErrorForbiddenNotAuthorized = exports.ResponseErrorUnauthorized = exports.ResponseErrorFromValidationErrors = exports.ResponseErrorValidation = exports.ResponseErrorNotFound = exports.ResponseErrorGeneric = exports.ResponseSuccessNoContent = exports.ResponseSuccessRedirectToResource = exports.ResponseSeeOtherRedirect = exports.ResponsePermanentRedirect = exports.ResponseSuccessAccepted = exports.ResponseSuccessXml = exports.ResponseSuccessJson = exports.ProblemJson = exports.HttpStatusCode = exports.HttpStatusCodeEnum = void 0;
const t = require("io-ts");
const reporters_1 = require("./reporters");
const types_1 = require("./types");
// see https://en.wikipedia.org/wiki/List_of_HTTP_status_codes
var HttpStatusCodeEnum;
(function (HttpStatusCodeEnum) {
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_200"] = 200] = "HTTP_STATUS_200";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_201"] = 201] = "HTTP_STATUS_201";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_202"] = 202] = "HTTP_STATUS_202";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_203"] = 203] = "HTTP_STATUS_203";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_204"] = 204] = "HTTP_STATUS_204";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_205"] = 205] = "HTTP_STATUS_205";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_206"] = 206] = "HTTP_STATUS_206";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_207"] = 207] = "HTTP_STATUS_207";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_208"] = 208] = "HTTP_STATUS_208";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_300"] = 300] = "HTTP_STATUS_300";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_301"] = 301] = "HTTP_STATUS_301";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_302"] = 302] = "HTTP_STATUS_302";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_303"] = 303] = "HTTP_STATUS_303";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_304"] = 304] = "HTTP_STATUS_304";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_305"] = 305] = "HTTP_STATUS_305";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_306"] = 306] = "HTTP_STATUS_306";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_307"] = 307] = "HTTP_STATUS_307";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_308"] = 308] = "HTTP_STATUS_308";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_400"] = 400] = "HTTP_STATUS_400";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_401"] = 401] = "HTTP_STATUS_401";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_402"] = 402] = "HTTP_STATUS_402";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_403"] = 403] = "HTTP_STATUS_403";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_404"] = 404] = "HTTP_STATUS_404";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_405"] = 405] = "HTTP_STATUS_405";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_406"] = 406] = "HTTP_STATUS_406";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_407"] = 407] = "HTTP_STATUS_407";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_408"] = 408] = "HTTP_STATUS_408";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_409"] = 409] = "HTTP_STATUS_409";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_410"] = 410] = "HTTP_STATUS_410";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_411"] = 411] = "HTTP_STATUS_411";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_412"] = 412] = "HTTP_STATUS_412";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_413"] = 413] = "HTTP_STATUS_413";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_414"] = 414] = "HTTP_STATUS_414";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_415"] = 415] = "HTTP_STATUS_415";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_416"] = 416] = "HTTP_STATUS_416";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_417"] = 417] = "HTTP_STATUS_417";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_418"] = 418] = "HTTP_STATUS_418";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_421"] = 421] = "HTTP_STATUS_421";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_422"] = 422] = "HTTP_STATUS_422";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_423"] = 423] = "HTTP_STATUS_423";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_424"] = 424] = "HTTP_STATUS_424";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_425"] = 425] = "HTTP_STATUS_425";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_426"] = 426] = "HTTP_STATUS_426";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_428"] = 428] = "HTTP_STATUS_428";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_429"] = 429] = "HTTP_STATUS_429";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_431"] = 431] = "HTTP_STATUS_431";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_451"] = 451] = "HTTP_STATUS_451";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_500"] = 500] = "HTTP_STATUS_500";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_501"] = 501] = "HTTP_STATUS_501";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_502"] = 502] = "HTTP_STATUS_502";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_503"] = 503] = "HTTP_STATUS_503";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_504"] = 504] = "HTTP_STATUS_504";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_505"] = 505] = "HTTP_STATUS_505";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_506"] = 506] = "HTTP_STATUS_506";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_507"] = 507] = "HTTP_STATUS_507";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_508"] = 508] = "HTTP_STATUS_508";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_510"] = 510] = "HTTP_STATUS_510";
    HttpStatusCodeEnum[HttpStatusCodeEnum["HTTP_STATUS_511"] = 511] = "HTTP_STATUS_511";
})(HttpStatusCodeEnum = exports.HttpStatusCodeEnum || (exports.HttpStatusCodeEnum = {}));
exports.HttpStatusCode = (0, types_1.enumType)(HttpStatusCodeEnum, "HttpStatusCode");
exports.ProblemJson = t.partial({
    detail: t.string,
    instance: t.string,
    status: exports.HttpStatusCode,
    title: t.string,
    type: (0, types_1.withDefault)(t.string, "about:blank"),
});
/**
 * Returns a successful json response.
 *
 * @param o The object to return to the client
 */
const ResponseSuccessJson = (o) => {
    const kindlessObject = Object.assign(Object.assign({}, o), {
        kind: undefined,
    });
    return {
        // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
        apply: (res) => res.status(HttpStatusCodeEnum.HTTP_STATUS_200).json(kindlessObject),
        kind: "IResponseSuccessJson",
        value: o,
    };
};
exports.ResponseSuccessJson = ResponseSuccessJson;
/**
 * Returns a successful xml response.
 *
 * @param o The object to return to the client
 */
const ResponseSuccessXml = (o) => ({
    // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
    apply: (res) => res
        .status(HttpStatusCodeEnum.HTTP_STATUS_200)
        .set("Content-Type", "application/xml")
        .send(o),
    kind: "IResponseSuccessXml",
    value: o,
});
exports.ResponseSuccessXml = ResponseSuccessXml;
/**
 * Returns a request accepted response.
 */
const ResponseSuccessAccepted = (detail, payload) => ({
    // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
    apply: (res) => payload === undefined
        ? res.send(HttpStatusCodeEnum.HTTP_STATUS_202)
        : res.status(HttpStatusCodeEnum.HTTP_STATUS_202).json(payload),
    detail,
    kind: "IResponseSuccessAccepted",
    payload,
});
exports.ResponseSuccessAccepted = ResponseSuccessAccepted;
/**
 * Returns a redirect response.
 *
 * @param o The object to return to the client
 */
const ResponsePermanentRedirect = (location) => ({
    // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
    apply: (res) => res.redirect(HttpStatusCodeEnum.HTTP_STATUS_301, location.href),
    detail: location.href,
    kind: "IResponsePermanentRedirect",
});
exports.ResponsePermanentRedirect = ResponsePermanentRedirect;
/**
 * Returns a HTTP_303 redirect response.
 *
 * @param location The url to redirect the client to
 */
const ResponseSeeOtherRedirect = (location) => ({
    // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
    apply: (res) => res.redirect(HttpStatusCodeEnum.HTTP_STATUS_303, location.href),
    detail: location.href,
    kind: "IResponseSeeOtherRedirect",
});
exports.ResponseSeeOtherRedirect = ResponseSeeOtherRedirect;
/**
 * Returns a successful response returning a redirect to a resource.
 */
const ResponseSuccessRedirectToResource = (resource, url, payload) => ({
    // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
    apply: (res) => res
        .set("Location", url)
        .status(HttpStatusCodeEnum.HTTP_STATUS_201)
        .json(payload),
    detail: url,
    kind: "IResponseSuccessRedirectToResource",
    payload,
    resource,
});
exports.ResponseSuccessRedirectToResource = ResponseSuccessRedirectToResource;
/**
 * Returns a successful response without content and with a status code of 204
 */
const ResponseSuccessNoContent = () => ({
    // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
    apply: (res) => res.status(HttpStatusCodeEnum.HTTP_STATUS_204).send(),
    kind: "IResponseSuccessNoContent",
});
exports.ResponseSuccessNoContent = ResponseSuccessNoContent;
/**
 * Returns a response describing a generic error.
 *
 * The error is translated to an RFC 7807 response (Problem JSON)
 * See https://zalando.github.io/restful-api-guidelines/index.html#176
 *
 */
const ResponseErrorGeneric = (status, title, detail, problemType) => {
    const problem = {
        detail,
        status,
        title,
        type: problemType,
    };
    return {
        // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
        apply: (res) => res
            .status(status)
            .set("Content-Type", "application/problem+json")
            .json(problem),
        detail: `${title}: ${detail}`,
        kind: "IResponseErrorGeneric",
    };
};
exports.ResponseErrorGeneric = ResponseErrorGeneric;
/**
 * Returns a response describing a 404 error.
 *
 * @param title The error message
 */
const ResponseErrorNotFound = (title, detail) => (Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_404, title, detail)), { detail: `${title}: ${detail}`, kind: "IResponseErrorNotFound" }));
exports.ResponseErrorNotFound = ResponseErrorNotFound;
/**
 * Returns a response describing a validation error.
 */
const ResponseErrorValidation = (title, detail) => (Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_400, title, detail)), { detail: `${title}: ${detail}`, kind: "IResponseErrorValidation" }));
exports.ResponseErrorValidation = ResponseErrorValidation;
/**
 * Returns a response describing a validation error.
 */
const ResponseErrorFromValidationErrors = (type) => (errors) => {
    const detail = (0, reporters_1.errorsToReadableMessages)(errors).join("\n");
    return (0, exports.ResponseErrorValidation)(`Invalid ${type.name}`, detail);
};
exports.ResponseErrorFromValidationErrors = ResponseErrorFromValidationErrors;
/**
 * Returns an unauthorized error response with status code 401.
 */
const ResponseErrorUnauthorized = (detail) => (Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_401, "Unauthorized", detail)), { detail: `Unauthorized: ${detail}`, kind: "IResponseErrorUnauthorized" }));
exports.ResponseErrorUnauthorized = ResponseErrorUnauthorized;
/**
 * Return an IResponseErrorForbiddenNotAuthorized with a default detail if not provided
 */
const getResponseErrorForbiddenNotAuthorized = (detail = "You do not have enough permission to complete the operation you requested") => (Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_403, "You are not allowed here", detail)), { kind: "IResponseErrorForbiddenNotAuthorized" }));
exports.getResponseErrorForbiddenNotAuthorized = getResponseErrorForbiddenNotAuthorized;
/**
 * The user is not allowed here.
 */
exports.ResponseErrorForbiddenNotAuthorized = (0, exports.getResponseErrorForbiddenNotAuthorized)();
/**
 * The user is not allowed to issue production requests.
 */
exports.ResponseErrorForbiddenNotAuthorizedForProduction = Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_403, "Production call forbidden", "You are not allowed to issue production calls at this time.")), { kind: "IResponseErrorForbiddenNotAuthorizedForProduction" });
/**
 * The user is not allowed to issue requests for the recipient.
 */
exports.ResponseErrorForbiddenNotAuthorizedForRecipient = Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_403, "Recipient forbidden", "You are not allowed to issue requests for the recipient.")), { kind: "IResponseErrorForbiddenNotAuthorizedForRecipient" });
/**
 * The user is not allowed to send messages with default addresses.
 */
exports.ResponseErrorForbiddenNotAuthorizedForDefaultAddresses = Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_403, "Call forbidden", "You are not allowed to send messages by providing default addresses.")), { kind: "IResponseErrorForbiddenNotAuthorizedForDefaultAddresses" });
/**
 * The user is anonymous.
 */
exports.ResponseErrorForbiddenAnonymousUser = Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_403, "Anonymous user", "The request could not be associated to a user, missing userId or subscriptionId.")), { kind: "IResponseErrorForbiddenAnonymousUser" });
/**
 * Return an IResponseErrorForbiddenNoAuthorizationGroups with a default detail if not provided
 */
const getResponseErrorForbiddenNoAuthorizationGroups = (description = "You are not part of any valid scope, you should ask the administrator to give you the required permissions.") => (Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_403, "User has no valid scopes", description)), { kind: "IResponseErrorForbiddenNoAuthorizationGroups" }));
exports.getResponseErrorForbiddenNoAuthorizationGroups = getResponseErrorForbiddenNoAuthorizationGroups;
/**
 * The user is not part of any valid authorization groups.
 */
exports.ResponseErrorForbiddenNoAuthorizationGroups = (0, exports.getResponseErrorForbiddenNoAuthorizationGroups)();
/**
 * Returns a response describing an conflict error (409).
 *
 * @param detail The error message
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function ResponseErrorConflict(detail) {
    return Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_409, "Conflict", detail)), { kind: "IResponseErrorConflict" });
}
exports.ResponseErrorConflict = ResponseErrorConflict;
/**
 * Returns a response describing an precondition failed error (412).
 *
 * @param detail The error message
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function ResponseErrorPreconditionFailed(detail, problemType) {
    return Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_412, "Precondition Failed", detail, problemType)), { kind: "IResponseErrorPreconditionFailed" });
}
exports.ResponseErrorPreconditionFailed = ResponseErrorPreconditionFailed;
/**
 * Returns a response describing a too many requests error (429).
 *
 * @param detail The error message
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function ResponseErrorTooManyRequests(detail) {
    return Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_429, "Too many requests", detail === undefined ? "" : detail)), { kind: "IResponseErrorTooManyRequests" });
}
exports.ResponseErrorTooManyRequests = ResponseErrorTooManyRequests;
/**
 * Returns a response describing an internal server error.
 *
 * @param detail The error message
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function ResponseErrorInternal(detail) {
    return Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_500, "Internal server error", detail)), { kind: "IResponseErrorInternal" });
}
exports.ResponseErrorInternal = ResponseErrorInternal;
/**
 * Returns a response describing a bad gateway error.
 *
 * @param detail The error message
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function ResponseErrorBadGateway(detail) {
    return Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_502, "Bad Gateway", detail)), { kind: "IResponseErrorBadGateway" });
}
exports.ResponseErrorBadGateway = ResponseErrorBadGateway;
/**
 * Returns a response describing a service unavailable error.
 *
 * @param detail The error message
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function ResponseErrorServiceUnavailable(detail) {
    return Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_503, "Service temporarily unavailable", detail)), { kind: "IResponseErrorServiceUnavailable" });
}
exports.ResponseErrorServiceUnavailable = ResponseErrorServiceUnavailable;
/**
 * Returns a response describing a service temporarily unavailable error.
 *
 * @param detail The error message
 * @param retryAfter seconds to wait for the Retry-After header
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function ResponseErrorServiceTemporarilyUnavailable(detail, retryAfter) {
    const title = "Service temporarily unavailable";
    const status = HttpStatusCodeEnum.HTTP_STATUS_503;
    const problem = {
        detail,
        status,
        title,
    };
    return {
        // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
        apply: (res) => res
            .status(status)
            .set("Content-Type", "application/problem+json")
            .set("Retry-After", retryAfter)
            .json(problem),
        detail: `${title}: ${detail}`,
        kind: "IResponseErrorServiceUnavailable",
    };
}
exports.ResponseErrorServiceTemporarilyUnavailable = ResponseErrorServiceTemporarilyUnavailable;
/**
 * Returns a response describing a gateway timeout error.
 *
 * @param detail The error message
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function ResponseErrorGatewayTimeout(detail) {
    return Object.assign(Object.assign({}, (0, exports.ResponseErrorGeneric)(HttpStatusCodeEnum.HTTP_STATUS_504, "Gateway Timeout", detail)), { kind: "IResponseErrorGatewayTimeout" });
}
exports.ResponseErrorGatewayTimeout = ResponseErrorGatewayTimeout;
/**
 * Returns a response with status 410 and a detail msg.
 */
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function ResponseErrorGone(detail) {
    return {
        // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
        apply: (res) => res.status(410).json({ detail }),
        kind: "IResponseErrorGone",
        value: { detail },
    };
}
exports.ResponseErrorGone = ResponseErrorGone;
//# sourceMappingURL=responses.js.map