"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SequenceMiddleware = void 0;
const TE = require("fp-ts/lib/TaskEither");
const E = require("fp-ts/lib/Either");
const T = require("fp-ts/lib/Task");
const RA = require("fp-ts/lib/ReadonlyArray");
const function_1 = require("fp-ts/lib/function");
const SequenceMiddleware = (defaultError) => (
// TODO: the helper is intended for an undefined number of middleware
// however, we decided to implement the simplest case so far (two middlewares only)
// Please enhance the type definition to allow more middlewares if needed
middleware0, middleware1
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
) => (request) => __awaiter(void 0, void 0, void 0, function* () {
    return yield (0, function_1.pipe)([middleware0, middleware1], RA.map((middleware) => (0, function_1.pipe)(TE.tryCatch(() => __awaiter(void 0, void 0, void 0, function* () {
        return (yield middleware(request));
    }), (_) => void 0 // We can ignore the error because we handle with defaultError
    ), TE.chainW(TE.fromEither))), T.sequenceSeqArray, T.map(RA.rights), T.map((rights) => rights.length > 0 ? E.of(rights[0]) : E.left(defaultError)))();
});
exports.SequenceMiddleware = SequenceMiddleware;
//# sourceMappingURL=sequence_middleware.js.map