/// <reference types="node" />
import * as url from "url";
import * as t from "io-ts";
export type ValidUrl = url.Url & {
    readonly href: string;
};
/**
 * io-ts type that decodes a Url from a string
 *
 * ie. UrlFromString.decode("http://example.com")
 */
export declare const UrlFromString: t.Type<ValidUrl, string, unknown>;
export type UrlFromString = t.TypeOf<typeof UrlFromString>;
export declare const HttpsUrlFromString: t.RefinementC<t.Type<ValidUrl, string, unknown>, ValidUrl>;
export type HttpsUrlFromString = t.Type<typeof HttpsUrlFromString>;
export declare const HttpUrlFromString: t.RefinementC<t.Type<ValidUrl, string, unknown>, ValidUrl>;
export type HttpUrlFromString = t.Type<typeof HttpUrlFromString>;
