"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpUrlFromString = exports.HttpsUrlFromString = exports.UrlFromString = void 0;
const url = require("url");
const t = require("io-ts");
const E = require("fp-ts/lib/Either");
const function_1 = require("fp-ts/lib/function");
const isUrl = (v) => 
// eslint-disable-next-line @typescript-eslint/no-explicit-any
t.object.is(v) && t.string.is(v.href);
/**
 * io-ts type that decodes a Url from a string
 *
 * ie. UrlFromString.decode("http://example.com")
 */
exports.UrlFromString = new t.Type("UrlFromString", isUrl, (v, c) => isUrl(v)
    ? t.success(v)
    : (0, function_1.pipe)(t.string.validate(v, c), E.chain((s) => {
        const d = url.parse(s);
        // we can safely use url.href in calling methods
        return !d.href ? t.failure(s, c) : t.success(d);
    })), (a) => a.href);
exports.HttpsUrlFromString = t.refinement(exports.UrlFromString, (o) => o.protocol === "https:");
exports.HttpUrlFromString = t.refinement(exports.UrlFromString, (o) => o.protocol === "http:");
//# sourceMappingURL=url.js.map